{-------------------------------------------------------------------------}
{  CHERCHE.PAS --> Recherche de fichiers sur l'ensemble d'une unit       }
{                     Affiche les fichiers cachs et les labels           }
{                                                                         }
{     Version  --> 3.01                                                   }
{     02.06.91 --> Date de cration                                       }
{     23.10.91 --> Date de dernire mise  jour                           }
{-------------------------------------------------------------------------}

PROGRAM Cherche;

USES Dos, Crt;

VAR
   fich_info  : Searchrec;
   chemin1    : STRING;            { rpertoire de dpart }
   masque     : STRING;            { masque de recherche }
   unite      : STRING[2];         { unit sur laquelle porte la recherche }
   total_fich : REAL;              { nbre total de fichiers trouvs }

{--------------------------------------------------Fonction LeadingZero---}
FUNCTION LeadingZero(w : WORD) : STRING;

VAR
   s : STRING;

BEGIN
   Str(w:0,s);
   IF Length(s) = 1 THEN
      s := '0' + s;
   LeadingZero := s;
END;

{---------------------------------------------Procdure Affiche_Fichier---}
PROCEDURE Affiche_Fichier;

VAR
   chemin : STRING;                { rpertoire en cours }
   rep    : CHAR;
   dt     : DateTime;

   (*
   P        : PathStr;
   D        : DirStr;
   N, blanc : NameStr;
   *)

BEGIN

   GetDir(0, chemin);

   (*
   P := fich_info.Name;
   FSplit(P, D, N, E);
   FillChar(blanc, 8, ' ');
   FillChar(blanc, 8 - Length(N), ' ');
   blanc[0] := Char(8 - Length(N));
   *)

   WITH fich_info DO

   IF (Name<>'.') AND (Name<>'..') THEN BEGIN

      UnpackTime(Time, dt);
      total_fich := total_fich + 1;
      WriteLn;

      {  Write(N, blanc, E, Size:8,  }

      Write(Name:12);

      CASE Attr OF
         16, 18: BEGIN   { Rpertoires cachs ou pas }
                      TextColor(14); Write ('<':6);
                      TextColor(7) ; Write ('R');
                      TextColor(14); Write ('>');
                      TextColor(7) ;
                 END;
         40    : BEGIN   { Labels }
                      TextColor(11); Write('<':6);
                      TextColor(7) ; Write ('L');
                      TextColor(11); Write ('>');
                      TextColor(7) ;
                 END
      ELSE Write (Size:8);
      END;


      Write(LeadingZero(dt.Day):4, '.',
            LeadingZero(dt.Month), '.', dt.Year, '  dans ', chemin);

      IF Frac(total_fich / 23) = 0.0 THEN BEGIN
         WriteLn; WriteLn;
         Write('   ------Pressez la BARRE ESPACE pour continuer ou ''S''',
               ' pour arrter------');
         REPEAT
               rep := UpCase(ReadKey);
         UNTIL rep IN ['S', ' '];
         WriteLn;
         IF (rep = 'S') THEN BEGIN
            ChDir(chemin1);
            Halt
         END
      END

   END;

   Exit;

END;

{-----------------------------------------Procdure rcursive Recherche---}
PROCEDURE Recherche;

VAR
   nbre_fich  : WORD;     { nbre de fichiers dans le rpertoire list }
   i          : WORD;

BEGIN
   nbre_fich:=0;
   FindFirst(masque, AnyFile, fich_info);
   IF DosError=0 THEN BEGIN
      Affiche_Fichier;
      REPEAT
         FindNext(fich_info);
         IF DosError=0 THEN Affiche_Fichier;
      UNTIL DosError<>0;
   END;
   FindFirst('*.*', Directory, fich_info);

   REPEAT
      WITH fich_info DO
      IF (Name<>'.') AND (Name<>'..') AND (Attr=Directory) THEN BEGIN
         ChDir(Name);
         Recherche;
         ChDir('..');
         FindFirst('*.*', Directory, fich_info);
         FOR i:=1 TO nbre_fich DO FindNext(fich_info);
      END;
      FindNext(fich_info);
      Inc(nbre_fich);
   UNTIL DosError<>0;

END;

{------------------------------------------Procdure Analyse_Parametres---}
PROCEDURE Analyse_Parametres;

VAR
   i : INTEGER;

BEGIN
   IF ParamCount <> 1 THEN BEGIN
      WriteLn;
      WriteLn('CHERCHE 3.01 - (c) mg, 10/1991');
      WriteLn;
      Write('CHERCHE affiche tous les fichiers d''une unit correspondant');
      WriteLn('  un masque donn.');
      WriteLn;
      WriteLn('Mode d''emploi -> cherche [masque de recherche]');
      WriteLn;
      Writeln('Exemples      -> cherche *.doc');
      WriteLn('                 cherche ibm???.com');
      WriteLn('                 cherche d:manuel.pac');
      WriteLn('                 cherche a:*.* ou cherche a:');
      Halt;
   END;

   GetDir(0, chemin1);

   { ParamStr(1) = unit+masque ou masque seul }
   unite := Copy(ParamStr(1), 1, 2);

   { Vrification de l'absence de '\' dans le masque de recherche }
   FOR i:=1 TO Length(ParamStr(1)) DO BEGIN
      IF Copy(ParamStr(1), i, 1) = '\' THEN BEGIN
         WriteLn('Le caractre ''\'' ne doit pas figurer ',
                 'dans le masque de recherche.');
         Halt
      END;
   END;

   {$I-}
   ChDir(unite);
   IF IOResult <> 0 THEN masque := ParamStr(1)
   ELSE masque := Copy(ParamStr(1), 3, Length(ParamStr(1))-2);
   ChDir('\');
   IF IOResult = 152 THEN BEGIN
      WriteLn('Unit non prte.');
      ChDir(chemin1);
      Halt
   END;
   {$I+}

   IF (masque='') OR (masque='*') THEN masque:='*.*';

END;

{---------------------------------------------------Programme Principal---}
BEGIN
   Analyse_Parametres;
   total_fich := 0;
   Recherche;
   CASE Round(total_fich) OF
      0: WriteLn('Correspondance non trouve.');
      1: BEGIN
            WriteLn; WriteLn;
            WriteLn('1 fichier trouv.');
         END;
   ELSE BEGIN
            WriteLn; WriteLn;
            WriteLn(Round(total_fich), ' fichiers trouvs.');
        END
   END;
   ChDir(chemin1)
END.